Package: meshr
Title: Tools for conducting enrichment analysis of MeSH
Description: A set of annotation maps describing the entire MeSH assembled using data from MeSH.
Version: 2.17.0
Author: Koki Tsuyuzaki, Itoshi Nikaido, Gota Morota
Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
Depends: R (>= 4.1.0)
Imports: markdown, rmarkdown, BiocStyle, knitr, methods, stats, utils,
        fdrtool, MeSHDbi, Category, S4Vectors, BiocGenerics, RSQLite
License: Artistic-2.0
biocViews: AnnotationData, FunctionalAnnotation, Bioinformatics,
        Statistics, Annotation, MultipleComparisons, MeSHDb
VignetteBuilder: knitr
BugReports: https://github.com/rikenbit/meshr/issues
git_url: https://git.bioconductor.org/packages/meshr
git_branch: devel
git_last_commit: edcebb9
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-10-31 22:40:08 UTC; biocbuild

import(methods)
import(fdrtool)
import(MeSHDbi)
import(Category)
import(S4Vectors)

importFrom(RSQLite, dbGetQuery)
importFrom(stats, p.adjust)
importFrom(utils, data, download.file, read.delim, setTxtProgressBar, txtProgressBar)
importFrom(BiocGenerics, annotation, "annotation<-")

exportClasses(MeSHHyperGParams, MeSHHyperGResult)

exportMethods(## Results
              "meshHyperGTest",
              "meshIds",
              "meshCategory",
              "meshAnnotation",
              "meshDatabase",
              "show",
              "summary",

              ## Params
              "initialize",
              "geneIds",
              "universeGeneIds",
              "universeGeneIds<-",
              "annotation",
              "annotation<-",
              category,
              "category<-",
              database,
              "database<-",
              "pvalueCutoff",
              "pvalueCutoff<-",
              "pAdjust",
              "pAdjust<-",
              "makeValidParams")

##
## Two classes defiend in meshr package
##

## Class to holds parameters that will be passed on to statistical test
setClass("MeSHHyperGParams",
        representation=representation(
          geneIds="ANY",
          universeGeneIds="ANY",
          annotation="character",
          meshdb="character",
          category="character",
          database="character",
          pvalueCutoff="numeric",
          pAdjust="character"
          ),
        prototype=prototype(
          pvalueCutoff=0.05,
          pAdjust="none"
          )
        )

## Class to holds MeSH enrichment analysis results
setClass("MeSHHyperGResult",
        representation=representation(
          meshCategory="character",
          meshAnnotation="character",
          meshDatabase="character",
          ORA="data.frame"
          )
        )

##
## Accessor methods for MeSHHyperGResult class
##

setMethod("meshCategory", "MeSHHyperGResult", function(r) r@meshCategory)

setMethod("meshAnnotation", "MeSHHyperGResult", function(r) r@meshAnnotation)

setMethod("meshDatabase", "MeSHHyperGResult", function(r) r@meshDatabase)

## generic is defined in methods/R/AllGenerics.R
setMethod("show", "MeSHHyperGResult", function(object){
	cat("MeSH enrichment analysis for category", object@meshCategory, '\n')
	cat("Annotation package used: ", object@meshAnnotation, '\n')
	cat("The correspondance is retrived from: ", object@meshDatabase, '\n')
	cat("Number of MeSH terms identified: ", length(object@ORA), '\n')
})

## generic is defined in base/R/AllGenerics.R
setMethod("summary", "MeSHHyperGResult", function(object){
	object@ORA
})

.sapply_pb <- function(X, FUN, ...)
{
  env <- environment()
  pb_Total <- length(X)
  counter <- 0
  pb <- txtProgressBar(min = 0, max = pb_Total, style = 3)

  wrapper <- function(...){
    curVal <- get("counter", envir = env)
    assign("counter", curVal +1 ,envir=env)
    setTxtProgressBar(get("pb", envir=env), curVal +1)
    FUN(...)
  }
  res <- sapply(X, wrapper, ...)
  close(pb)
  res
}

##
## Accessor methods for MeSHHyperParams class
##


## check MeSHHyperParams instance for validity.
## If we can fix it, we do (and issue a warning)
## Return a more valid instance or error
## Based on Category/R/HyperGParams-accessors.R
.makeValidMeSHParams <- function(object) {
  ##
  ## Validation of MeSH version
  ##
  MeSH.db <- eval(parse(text=object@meshdb))
  MeSH.XXX.eg.db <- eval(parse(text=object@annotation))
  if(meshVersion(MeSH.db)[1,2] != meshVersion(MeSH.XXX.eg.db)[1,2]){
    stop("\n#############################################################################\nMeSH-version of MeSH.db and MeSH.XXX.eg.db-type packages must be coincided!\nPlease confirm the version of MeSH by typing\n\n'meshVersion(MeSH.db)'\n\n'meshVersion(MeSH.XXX.eg.db)'\n\nand then install appropriate version of these packages\n#############################################################################")
  }
  ##
  ##
  ##

  sel <- geneIds(object)
  if (is.list(sel)) {
    warning("converting geneIds from list to atomic vector via unlist")
    sel <- unlist(sel)
  }
  if (any(duplicated(sel))) {
    warning("removing duplicate IDs in geneIds")
    sel <- unique(sel)
  }
  geneIds(object) <- sel
  univ <- universeGeneIds(object)
  if (length(univ)) {
    if (is.list(univ)) {
      warning("converting univ from list to atomic vector via unlist")
      univ <- unlist(univ)
    }
        if (typeof(sel) != typeof(univ))
          stop(paste("geneIds and universeGeneIds must have the same mode\n",
                     "geneIds:", typeof(sel), "\n",
                     "universeGeneIds:", typeof(univ)), .Call=FALSE)
    if (any(duplicated(univ))) {
      warning("removing duplicate IDs in universeGeneIds")
      univ <- unique(univ)
    }
    universeGeneIds(object) <- univ
    if (!all(sel %in% univ)) {
      warning("removing geneIds not in universeGeneIds")
      sel <- intersect(sel, univ)
      if (!length(sel))
        stop("no geneIds in universeGeneIds", .Call=FALSE)
      geneIds(object) <- sel
    }
  }
  pv <- pvalueCutoff(object)
  if (pv > 1 || pv < 0){
    stop("invalid pvalueCutoff, must be between 0 and 1", .Call=FALSE)}
  return(object)
}

## Based on Category/R/HyperGParams-accessors.R
## Generic is defiend in Category/R/AllGenerics.R
setMethod("makeValidParams", "MeSHHyperGParams", .makeValidMeSHParams)

## Based on Category/R/HyperGParams-accessors.R
## Generic is defined in GSEABase/R/AllGenerics.R
setMethod("geneIds", "MeSHHyperGParams", function(object, ...) object@geneIds)
setReplaceMethod("geneIds", "MeSHHyperGParams", function(object, value) {
    object@geneIds <- value
    object
  })

## Based on Category/R/HyperGParams-accessors.R
## Generic is defiend in Category/R/AllGenerics.R
setMethod("universeGeneIds", "MeSHHyperGParams", function(r) r@universeGeneIds)
setReplaceMethod("universeGeneIds", "MeSHHyperGParams", function(r, value) {
    r@universeGeneIds <- value
    r
  })

## Based on Category/R/HyperGParams-accessors.R
## Generic is defiend in Category/R/AllGenerics.R
setMethod("annotation", "MeSHHyperGParams", function(object) object@annotation)
setReplaceMethod("annotation", c("MeSHHyperGParams", "character"),
                 function(object, value) {
                   object@annotation <- value
                   object
                 })

## Our original
setMethod("category", "MeSHHyperGParams", function(r) r@category)
setReplaceMethod("category", c("MeSHHyperGParams", "character"),
    function(r, value) {
    r@category <- value
    r
  })

## Our original
setMethod("database", "MeSHHyperGParams", function(r) r@database)
setReplaceMethod("database", c("MeSHHyperGParams", "character"),
    function(r, value) {
    r@database <- value
    r
  })


setMethod("pAdjust", "MeSHHyperGParams", function(r) r@pAdjust)
setReplaceMethod("pAdjust", c("MeSHHyperGParams", "character"),
    function(r, value) {
    r@pAdjust <- value
    r
  })


## Based on Category/R/HyperGParams-accessors.R
## Generic is defined in Category/R/AllGeneric.R
setMethod("pvalueCutoff", "MeSHHyperGParams", function(r) r@pvalueCutoff)
setReplaceMethod("pvalueCutoff", "MeSHHyperGParams", function(r, value) {
    r@pvalueCutoff <- value
    r
})

##
## Generic functions
##

## This is already defiend in Category/R/AllGenerics.R but seems like required.
## Probably because this is not listed in exportMethods() of Category/NAMESPACE?
setGeneric("universeGeneIds<-",
           function(r, value) standardGeneric("universeGeneIds<-"))
setGeneric("universeGeneIds", function(r) standardGeneric("universeGeneIds"))

setGeneric("pAdjust", function(r) standardGeneric("pAdjust"))
setGeneric("pAdjust<-", function(r, value) standardGeneric("pAdjust<-"))

setGeneric("pvalueCutoff<-", function(r, value) standardGeneric("pvalueCutoff<-"))

setGeneric("meshIds", function(r) standardGeneric("meshIds"))

setGeneric("meshTerms", function(r) standardGeneric("meshTerms"))

setGeneric("meshCategory", function(r) standardGeneric("meshCategory"))

setGeneric("meshAnnotation", function(r) standardGeneric("meshAnnotation"))

setGeneric("category", function(r) r@category)
setGeneric("category<-",
    function(r, value) standardGeneric("category<-")
)

setGeneric("database", function(r) r@database)
setGeneric("database<-",
    function(r, value) standardGeneric("database<-")
)

setGeneric("meshDatabase", function(r) standardGeneric("meshDatabase"))

setGeneric("meshHyperGTest",
           function(p) standardGeneric("meshHyperGTest"),
           valueClass="MeSHHyperGResult")

setMethod("meshHyperGTest", signature(p="MeSHHyperGParams"),
          function(p) .meshHyperGTestInternal(p) )

.meshHyperGTestInternal <- function(p) {
  ##
  ## Initialization
  ##

  ##
  ## MeSH enrichment analysis
  ##

  ## Map gene ID to MeSH ID through annotation data
  geneids <- as.data.frame(p@geneIds)
  universe.geneids <- as.data.frame(p@universeGeneIds)
  names(geneids) <- "GENEID"
  names(universe.geneids) <- "GENEID"
  query <- paste0("SELECT GENEID, MESHID, SOURCEID FROM DATA WHERE MESHCATEGORY = '",
    p@category, "' AND SOURCEDB = '", p@database, "';")
  selectedDatabase <- unique(dbGetQuery(dbconn(eval(parse(text=p@annotation))), query))
  selected.mesh <- table(merge(geneids, unique(selectedDatabase[,1:2]), "GENEID")[,2])
  universe.mesh <- table(merge(universe.geneids, unique(selectedDatabase[,1:2]), "GENEID")[,2])

  ## Hypergeometric test
  tmp <- sapply(names(selected.mesh), function(i){
    numWdrawn <- selected.mesh[i]
    numW <- universe.mesh[which(names(selected.mesh[i])==names(universe.mesh))]
    numB <- length(p@universeGeneIds) - numW
    numDrawn <- length(p@geneIds)
    scores <- Category:::.doHyperGInternal(numW, numB, numDrawn, numWdrawn, over=T)
    ## Assign statistics
    list(
      names(selected.mesh[i]),
      as.numeric(scores$p),
      as.numeric(scores$odds),
      as.numeric(scores$expected),
      as.numeric(numWdrawn),
      as.numeric(numW)
      )
   })
   outputA <- data.frame(
      MESHID = as.character(unlist(tmp[1,])),
      Pvalue = as.numeric(unlist(tmp[2,])),
      OddsRatio = as.numeric(unlist(tmp[3,])),
      ExpCount = as.numeric(unlist(tmp[4,])),
      Count = as.numeric(unlist(tmp[5,])),
      Size = as.numeric(unlist(tmp[6,]))
      )

  ## Multiple testing correction
  Pvalue <- outputA$Pvalue
  stats <- switch(p@pAdjust,
    BH = {
      p.adjust(Pvalue, "BH")},
    QV = {
      non_nan <- which(!is.nan(Pvalue))
      pre_stats <- rep(NaN, length=length(Pvalue))
      pre_stats[non_nan] <- fdrtool(Pvalue[non_nan], statistic="pvalue", plot=FALSE, verbose=FALSE)$qval
      pre_stats},
    lFDR = {
      non_nan <- which(!is.nan(Pvalue))
      pre_stats <- rep(NaN, length=length(Pvalue))
      pre_stats[non_nan] <- fdrtool(Pvalue[non_nan], statistic="pvalue", plot=FALSE, verbose=FALSE)$lfdr
      pre_stats},
    none = {
      Pvalue}
  )

  if(p@pAdjust != "none"){
    outputA <- cbind(outputA, stats)
    colnames(outputA)[which(colnames(outputA) == "stats")]  <- p@pAdjust
    colnames(outputA) <- c("MESHID", "Pvalue", "OddsRatio", "ExpCount", "Count", "Size", p@pAdjust)
  }

  ## Choose siginificantly enriched MeSH terms
  if(length(which(stats < p@pvalueCutoff)) != 0){
      outputA <- outputA[which(stats < p@pvalueCutoff), ]
    }else{
      outputA <- outputA[1,]
      outputA[,] <- NA
      warning("None of MeSH Term is significant !")
    }

  MeSH.db <- eval(parse(text=p@meshdb))
  out2 <- dbGetQuery(dbconn(MeSH.db), "SELECT * FROM DATA;")
  tmp2 <- sapply(names(selected.mesh), function(i){
    target <- which(out2$MESHID == i)
    unique(out2[target, c("MESHID", "MESHTERM")])
  })
  FromMeSHdb <- data.frame(
    MESHID=unlist(tmp2["MESHID", ]),
    MESHTERM=unlist(tmp2["MESHTERM", ]))

  outputB <- merge(FromMeSHdb, selectedDatabase, by = "MESHID")
  output <- merge(outputA, outputB, by = "MESHID")
  output <- output[order(output$Pvalue), ]

  ## Retrieve full name of MeSH category
  mesh.full.cat <- c(
     "Anatomy",
     "Organisms",
     "Diseases",
     "Chemicals and Drugs",
     "Analytical, Diagnostic and Therapeutic Techniques and Equipment",
     "Psychiatry and Psychology",
     "Phenomena and Processes",
     "Disciplines and Occupations",
     "Anthropology, Education, Sociology and Social Phenomena",
     "Technology and Food and Beverages",
     "Humanities",
     "Information Science",
     "Persons",
     "Health Care",
     "Publication Type",
     "Geographical Locations"
  )
  names(mesh.full.cat) <- c(
     "A", "B", "C", "D", "E", "F", "G", "H",
     "I", "J", "K", "L", "M", "N", "V", "Z"
  )
  mesh.full.cat <- mesh.full.cat[p@category]

  new("MeSHHyperGResult",
      meshCategory=mesh.full.cat,
      meshAnnotation=p@annotation,
      meshDatabase=p@database,
      ORA=as.data.frame(output)
  )
}

---
title: "AnnotationHub-style MeSH ORA Framework from BioC 3.14"
author:
- name: Koki Tsuyuzaki
  affiliation: Laboratory for Bioinformatics Research,
    RIKEN Center for Biosystems Dynamics Research
- name: Gota Morota
  affiliation: Virginia Polytechnic Institute and State University
- name: Manabu Ishii
  affiliation: Genome Analytics Japan
- name: Takeru Nakazato
  affiliation: Database Center for Life Science, Research Organization of Information and Systems
- name: Itoshi Nikaido
  affiliation: Laboratory for Bioinformatics Research,
    RIKEN Center for Biosystems Dynamics Research
  email: k.t.the-answer@hotmail.co.jp
package: meshr
output:
  BiocStyle::html_document
vignette: |
  %\VignetteIndexEntry{AnnotationHub-style MeSH ORA Framework from BioC 3.14}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# What is MeSH?

MeSH (Medical Subject Headings) is the NLM (U. S. National Library of Medicine) controlled vocabulary used to manually index articles for MEDLINE/PubMed^[S. J. Nelson and et al. The MeSH translation maintenance system: structure, interface design, and implementation. Stud. Health Technol. Inform., 107: 67-69, 2004.] and is a collection of a comprehensive life science vocabulary.

![Figure 1 : MeSH Term](fig1.png)

# What is MeSH ORA Framework?

MeSH contains more than 25,000 clinical and biological terms. The amount of MeSH term is about twice as large as that of GO (Gene Ontology)^[M. Ashburner and et al. Gene ontology: tool for the unification of biology. The Gene Ontology Consortium. Nat. Genet., 25(1): 25-29, 2000.] and its categories are also wider. Therefore MeSH is expected to be a much detailed and exhaustive gene annotation tool. In particular, MeSH can be an excellent source of information for minor species with small research populations and many genes that have not yet been functionally annotated.

Since BioC 2.14 (Apr. 2014), we have been distributing the information about MeSH itself (`MeSH.db`/`MeSH.AOR.db`/`MeSH.PCR.db`) and the correspondence between MeSH and genes of more than 100 species (`MeSH.XXX.eg.db`-type package) as annotation packages. We have also distributed a software package (`r Biocpkg("MeSHDbi")`) to define classes for the above annotation packages and to help users create their annotation packages, and a software package (`r Biocpkg("meshr")`) to perform enrichment analysis using the `MeSH.XXX.eg.db`-type package. Here, we call these MeSH-related packages MeSH ORA framework. Please refer to the previous vignette^[https://bioconductor.org/packages/3.13/bioc/vignettes/meshr/inst/doc/MeSH.pdf] for the description of creating individual data packages.

# Specification change of MeSH ORA Framework from BioC 3.14 (Nov. 2021)

The specifications of the MeSH ORA framework have changed significantly since BioC 3.14. Specifically, the distribution of all annotation packages will be abolished, and the policy has been switched to one where the data is placed on a cloud server called AnnotationHub, and users are allowed to retrieve the data only when they really need it. Note that this change will also change the specifications of all software packages that used the previous MeSH annotation packages, so backward compatibility will no longer be maintained.

The following are the advantages of this AnnotationHub-style.

- The installation time of the entire Bioconductor packages will be reduced.
- Old data will be archived.
- Data reproducibility is ensured (e.g. the version of the data can be specified, such as "v002").

In the following sections, we will show you how to use the new AnnotationHub-style MeSH ORA framework. If you want to check the previous style of the MeSH ORA framework for some reason, please check the vignette of meshr in BioC 3.13^[https://bioconductor.org/packages/3.13/bioc/vignettes/meshr/inst/doc/MeSH.pdf].

# Access to MeSH data on AnnotationHub

To access the MeSH datasets on AnnotationHub, we firstly install and load the `r Biocpkg("AnnotationHub")` package.

```{r Access1, eval=FALSE}
library("AnnotationHub")
```

`AnnotationHub()` returns the metadata of all the data stored in the AnnotationHub server.

```{r Access2, eval=FALSE}
ah <- AnnotationHub()
```

`mcol()` reshapes the result of `ah` as follows.

```{r Access3, eval=FALSE}
head(mcols(ah))
```

`query()` returns the details of a specific entry of AnnotationHub. Note that this just returns the metadata and not actual data.

```{r Access4, eval=FALSE}
mcols(query(ah, c("MeSHDb", "MeSH.db", "v002")))
```

By specifying some keywords and adding [[1]] with the `query()`, `query()` downloads the data to our local machine. The internal data (SQLite files) of the previous MeSH annotation packages will be stored as a cache on our local machines by the `r Biocpkg("BiocFileCache")` mechanism.

```{r Access5, eval=FALSE}
dbfile1 <- query(ah, c("MeSHDb", "MeSH.db", "v002"))[[1]]
dbfile2 <- query(ah, c("MeSHDb", "MeSH.AOR.db", "v002"))[[1]]
dbfile3 <- query(ah, c("MeSHDb", "MeSH.PCR.db", "v002"))[[1]]
dbfile4 <- query(ah, c("MeSHDb", "Danio rerio", "v002"))[[1]]
dbfile5 <- query(ah, c("MeSHDb", "Pseudomonas aeruginosa PAO1", "v002"))[[1]]
```

These SQLite files can be immediately converted into `MeSHDb` objects by running `MeSHDbi::MeSHDb` and can be used for the MeSH enrichment analysis described in the next section.

```{r Access6, eval=FALSE}
library("MeSHDbi")
MeSH.db <- MeSHDbi::MeSHDb(dbfile1)
MeSH.AOR.db <- MeSHDbi::MeSHDb(dbfile2)
MeSH.PCR.db <- MeSHDbi::MeSHDb(dbfile3)
MeSH.Dre.eg.db <- MeSHDbi::MeSHDb(dbfile4)
MeSH.Pae.PAO1.eg.db <- MeSHDbi::MeSHDb(dbfile5)
```

# MeSH Enrichment Analysis

After the conversion of `MeSHDb` objects from SQLite files as described above, MeSH enrichment analysis can be performed by the `r Biocpkg("meshr")` package in much the same way as before BioC 3.13, as follows. For the details of MeSH enrichment analysis, please check the vignette of `r Biocpkg("meshr")` in BioC 3.13^[https://bioconductor.org/packages/3.13/bioc/vignettes/meshr/inst/doc/MeSH.pdf].

```{r EA1, eval=FALSE}
library("meshr")

# dummy geneids for demo
geneid <- keys(MeSH.Pae.PAO1.eg.db, keytype="GENEID")
set.seed(1234)
sig.geneid <- sample(geneid, 500)

meshParams <- new("MeSHHyperGParams",
    geneIds = sig.geneid,
    universeGeneIds = geneid,
    annotation = "MeSH.Pae.PAO1.eg.db",
    meshdb = "MeSH.db", # Newly added parameter from BioC 3.14
    category = "A",
    database = "Escherichia coli str. K-12 substr. MG1655",
    pvalueCutoff = 0.5, pAdjust = "BH")
meshR <- meshHyperGTest(meshParams)
```

One point to note is that previously only the `MeSH.XXX.eg.db`-type object had to be prepared in advance and specified as the `annotation` argument, but now due to the `r Biocpkg("AnnotationHub")`, `MeSH.db` object must also be prepared in advance and specified as a `meshdb` argument like above.

After performing MeSH enrichment analysis, we can check the result of the test by `summary()`.

```{r EA2, eval=FALSE}
head(summary(meshR))
```

Switching to test another MeSH category and database can be easily done. For example, to choose the category as `B` (Organisms) and the database as reciprocal BLAST best hit (RBBH) with Bacillus subtilis, we can do the following.

```{r EA3, eval=FALSE}
category(meshParams) <- "B"
database(meshParams) <- "Bacillus subtilis subsp. subtilis str. 168"
meshR <- meshHyperGTest(meshParams)
head(summary(meshR))
```

# Session Information {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

\name{database}
\docType{methods}

\alias{generic,database}
\alias{database}
\alias{database<-}
\alias{database,MeSHHyperGParams-method}
\alias{database<-,MeSHHyperGParams,character-method}

\title{A function to return the name of MeSH database}
\description{This function returns the name of MeSH database.}

\usage{
database(r)
database(r) <- value
}

\arguments{
  \item{r}{
    An object containing annotation information.
  }
  \item{value}{
    The annotation information to set on \code{object}.
  }
}
\author{Koki Tsuyuzaki}

\examples{
showMethods("database")
}

\keyword{methods}

\name{meshr-package}
\alias{meshr-package}
\alias{meshr}
\docType{package}
\title{
Enrichment analysis for MeSH terms.
}
\description{
  meshr package conducts a MeSH enrichment analysis employing gene-MeSH
  annotation data. A hypergeometric test accounting for a multiple
  tesing correction is used to find significantly enriched MeSH terms.
}
\details{
\tabular{ll}{
Package: \tab meshr\cr
Version: \tab 1.2.6\cr
Date: \tab 3-20-2015\cr
biocViews: \tab AnnotationData, FunctionalAnnotation, Bioinformatics, Statistics, Annotation, MultipleComparisons\cr
Depends: \tab R (>= 3.0.1), cummeRbund, org.Hs.eg.db, fdrtool, Category, BiocGenerics, methods, MeSH.db, MeSH.AOR.db, MeSH.PCR.db, MeSHDbi, MeSH.Hsa.eg.db, MeSH.Aca.eg.db, MeSH.Atu.K84.eg.db, MeSH.Bsu.168.eg.db, MeSH.Syn.eg.db\cr
Imports: \tab \cr
Suggests: \tab \cr
License: \tab Artistic-2.0\cr
}

Index:
\preformatted{
meshHyperGTest performs a hypergeometric statistical test.
}

Further information is available in the vignettes.

}
\author{
Gota Morota, Koki Tsuyuzaki, Takeru Nakazato, Itoshi Nikaido

Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
}

\examples{
ls("package:meshr")
}

\seealso{
  \code{\link{MeSHHyperGParams-class}},  \code{\link{MeSHHyperGResult-class}},
  \code{\link{meshHyperGTest}}
}

\keyword{ package }

\name{category}
\docType{methods}

\alias{generic,category}
\alias{category}
\alias{category<-}
\alias{category,MeSHHyperGParams-method}
\alias{category<-,MeSHHyperGParams,character-method}

\title{A function to return the name of MeSH category}
\description{This function returns the name of MeSH category.}

\usage{
category(r)
category(r) <- value
}

\arguments{
  \item{r}{
    An object containing annotation information.
  }
  \item{value}{
    The annotation information to set on \code{object}.
  }
}
\author{Koki Tsuyuzaki}

\examples{
showMethods("category")
}

\keyword{methods}

\name{MeSHHyperGResult-class}
\docType{class}
\alias{MeSHHyperGResult-class}

\alias{meshIds}
\alias{meshIds,MeSHHyperGResult-method}

\alias{meshTerms}
\alias{meshTerms,MeSHHyperGResult-method}

\alias{meshCategory}
\alias{meshCategory,MeSHHyperGResult-method}

\alias{meshAnnotation}
\alias{meshAnnotation,MeSHHyperGResult-method}

\alias{meshDatabase}
\alias{meshDatabase,MeSHHyperGResult-method}

\alias{pvalues}
\alias{pvalues,MeSHHyperGResult-method}

\alias{show}
\alias{show,MeSHHyperGResult-method}

\alias{summary}
\alias{summary,MeSHHyperGResult-method}

\title{Class "MeSHHyperGResult"}

\description{
  This class represents the results of a test for overrepresentation
  of MeSH terms among genes in a selected gene set based upon the
  Hypergeometric distribution.

  For details on extracting information from this object, please read
  the documentation in the \link[meshr]{MeSHHyperGParams-class}.
}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MeSHHyperGResult", ...)}.
}


\section{Slots}{
   \describe{
    \item{\code{meshCategory}:}{Object of class \code{"character"} representing the category of MeSH terms tested.}
    \item{\code{meshAnnotation}:}{Object of class \code{"character"}.  The name of the annotation data used in the analysis.}
    \item{\code{meshDatabase}:}{Object of class \code{"character"}.  The name of the database used in the analysis.}
    \item{\code{ORA}:}{Object of class \code{"data.frame"}.  MeSH IDs, MeSH Terms, P-value, and other statistics is returned.}
  }
}


\section{Methods}{
  \describe{
    \item{meshCategory}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the MeSH category used in the analysis.}

    \item{meshAnnotation}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the name of the annotation data used in the analysis.}

    \item{meshDatabase}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the name of the database used in the analysis.}

    \item{meshIds}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the character vector of the MeSH IDs identified  as significant
      in the analysis. }

    \item{meshTerms}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the character vector of the MeSH terms identified  as significant
      in the analysis. }

    \item{pvalues}{\code{signature(r = "MeSHHyperGResult")}:
      Returns the associated p-values of significantly enriched MeSH terms.}

  \item{summary}{\code{signature(r = "MeSHHyperGResult")}: Returns a
      \code{data.frame} summarizing the test result.  Optional
      arguments \code{pvalue} and \code{categorySize} allow
      specification of maximum p-value and minimum categorySize,
      respectively.  Optional argument \code{htmlLinks} is a logical
      value indicating whether to add HTML links (useful in
      conjunction with xtables print method with \code{type} set to
      \code{"html"}).}

  \item{show}{\code{signature(object = "MeSHHyperGResult")}:
      Return a short description of the result.}
  }
}

\author{
Gota Morota, Koki Tsuyuzaki, Takeru Nakazato, Itoshi Nikaido

Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
}


\seealso{
  \code{\link{meshr-package}},  \code{\link{MeSHHyperGParams-class}},
  \code{\link{meshHyperGTest}}
}


\keyword{classes}

\name{meshHyperGTest}
\alias{meshHyperGTest}
\alias{meshHyperGTest,MeSHHyperGParams-method}

\title{Hypergeometric Tests for MeSH term association}

\description{ Given a \code{MeSHHyperGParams} object
  containing a set of selected and background gene IDs,
  and gene-MeSH annotation data of interest, \code{meshHyperGTest}
  performs Hypergeomtric test for over-representation of each MeSH term
  accouting for the multiple testing correction.  }

\arguments{
  \item{p}{A \code{MeSHHyperGParams} object }
}

\details{

  For details on creating \code{MeSHHyperGParams} object, please read
  the documentation in the \link[meshr]{MeSHHyperGParams-class}.

}

\value{
  A \code{MeSHHyperGResult} object.
}


\author{
Gota Morota, Koki Tsuyuzaki, Takeru Nakazato, Itoshi Nikaido

Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
}


\examples{
showMethods("meshHyperGTest")
}


\seealso{
  \code{\link{meshr-package}}, \code{\link{MeSHHyperGParams-class}},
  \code{\link{MeSHHyperGResult-class}}
}


\keyword{models}

\name{MeSHHyperGParams-class}
\docType{class}
\alias{MeSHHyperGParams-class}

\alias{initialize,MeSHHyperGParams-method}

\alias{geneIds,MeSHHyperGParams-method}
\alias{geneIds<-,MeSHHyperGParams,logical-method}
\alias{geneIds<-,MeSHHyperGParams,ANY-method}

\alias{universeGeneIds}
\alias{universeGeneIds<-}
\alias{universeGeneIds,MeSHHyperGParams-method}
\alias{universeGeneIds<-,MeSHHyperGParams-method}
\alias{universeGeneIds<-,MeSHHyperGParams,logical-method}
\alias{universeGeneIds<-,MeSHHyperGParams,ANY-method}

\alias{annotation,MeSHHyperGParams-method}
\alias{annotation<-,MeSHHyperGParams,character-method}

\alias{pvalueCutoff,MeSHHyperGParams-method}
\alias{pvalueCutoff<-,MeSHHyperGParams-method}

\alias{pAdjust}
\alias{pAdjust<-}
\alias{pAdjust,MeSHHyperGParams-method}
\alias{pAdjust<-,MeSHHyperGParams,character-method}


\alias{makeValidParams,MeSHHyperGParams-method}

\title{Class "MeSHHyperGParams"}

\description{
  A parameter class for representing all parameters needed for
  running the 'meshHyperGTest' method with one of the MeSH categories
  ("Anatomy", "Organisms", "Diseases", "Chemicals and Drugs", "Analytical, Diagnostic and Therapeutic Techniques and Equipment", "Psychiatry and Psychology", "Phenomena and Processes", "Disciplines and Occupations", "Anthropology, Education, Sociology and Social Phenomena", "Technology and Food and Beverages", "Humanities", "Information Science", "Persons", "Health Care", "Publication Type", "Geographical Locations").
}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("MeSHHyperGParams", ...)}.
}

\section{Slots}{
  \describe{
    \item{\code{geneIds}:}{Object of class \code{"ANY"}: A vector of
      gene identifiers.  Numeric and character vectors are probably the
      only things that make sense.  These are the gene ids for the
      selected gene set.}
    \item{\code{universeGeneIds}:}{Object of class \code{"ANY"}: A
      vector of gene ids in the same format as \code{geneIds} defining a
      subset of the gene ids on the chip that will be used as the
      universe for the hypergeometric calculation.}
    \item{\code{annotation}:}{A string giving the name of the
      gene-MeSH annotation package like MeSH.XXX.eg.db.}
    \item{\code{meshdb}:}{A string giving the name of the
      MeSH database like MeSH.db.}
    \item{\code{category}:}{A string giving the name of the
      MeSH category like A, B, C, D, ...and so on.}
    \item{\code{database}:}{A string giving the name of the
      MeSH database like gendoo, gene2pubmed, ...and so on.}
    \item{\code{pvalueCutoff}:}{A numeric values between zero and one
      used as a p-value or FDR cutoff for hypergeometric test
      depending on \code{pAdjust}. The default is set to 0.05. }
    \item{\code{pAdjust}:}{A string which can be one of the
      Benjamini-Hochberg procedure (a.k.a. q-value) ("BH"), Q-value
      ("QV"), empirical Bayes method ("lFDR"), and unadjusted p-value
      ("none") for multiple testing correction. }
  }
}

\section{Methods}{
  \describe{

    \item{\code{geneIds(p)}, \code{geneIds(p) <- value}}{Accessor
      methods for the geneIds.}

    \item{\code{universeGeneIds(p)}, \code{universeGeneIds(p) <- value}}{Accessor methods for the geneIds.}

    \item{\code{annotation(p)}, \code{annotation(p) <- value}}{Accessor methods for the gene-MeSH annotation data.}

    \item{\code{pAdjust(p)}}{An accessor method for the choice of a method for multiple testing correction. }

    \item{\code{pvalueCutoff(p)}}{An accessor method for the choice of a threshold when conducting enrichment analysis. }
  }
}

\author{
Gota Morota, Koki Tsuyuzaki, Takeru Nakazato, Itoshi Nikaido

Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>
}

\seealso{
  \code{\link{meshr-package}},  \code{\link{MeSHHyperGResult-class}},
  \code{\link{meshHyperGTest}}, \code{\link{category}}, \code{\link{database}}
}

\keyword{classes}
